//---------------------------------------------------------------------------

#include <stdio.h >
#include <vcl.h>
#pragma hdrstop

#include "main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CPDrv"
#pragma link "OpenDir"
#pragma link "BmDelay"
#pragma resource "*.dfm"
TForm1 *Form1;

const char *DAY_OF_WEEK_ARRAY[] = {"ANY DAY", "SUNDAY", "MONDAY", "TUESDAY", "WEDNESDAY", "THURSDAY", "FRIDAY", "SATURDAY","SPECIAL"};
const char *KIND_OF_TIME_ARRAY[] = {"", " BSR", " ASR", " BSS", " ASS"};
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
    PlaylistStruct *play_list_ptr;
    for(int i=0;i<100;i++) {
        play_list_ptr = &play_list_entries[i];
        memset(play_list_ptr,0x00,sizeof(PlaylistStruct));
        play_list_ptr->ShowNum = 0xFF;
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Exit1Click(TObject *Sender)
{
    Close();
}
//---------------------------------------------------------------------------



void __fastcall TForm1::COM11Click(TObject *Sender)
{
    TMenuItem *item;
    int i;

    for(i=0;i<MainMenu->Items[0].Items[1]->Count;i++) MainMenu->Items[0].Items[1]->Items[i]->Checked = false;

    item = MainMenu->Items[0].Items[1]->Find("COM1");
    if(item == NULL) return;
    item->Checked = true;
    CommPortDriver->Disconnect();
    CommPortDriver->Port = pnCOM1;
    ConnectComPort();


}
//---------------------------------------------------------------------------

void __fastcall TForm1::COM21Click(TObject *Sender)
{
 TMenuItem *item;
    int i;

    for(i=0;i<MainMenu->Items[0].Items[1]->Count;i++) MainMenu->Items[0].Items[1]->Items[i]->Checked = false;

    item = MainMenu->Items[0].Items[1]->Find("COM2");
    if(item == NULL) return;
    item->Checked = true;
    CommPortDriver->Disconnect();
     CommPortDriver->Port = pnCOM2;
     ConnectComPort();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::COM31Click(TObject *Sender)
{
    TMenuItem *item;
    int i;

    for(i=0;i<MainMenu->Items[0].Items[1]->Count;i++) MainMenu->Items[0].Items[1]->Items[i]->Checked = false;

    item = MainMenu->Items[0].Items[1]->Find("COM3");
    if(item == NULL) return;
    item->Checked = true;
    CommPortDriver->Disconnect();
    CommPortDriver->Port = pnCOM3;
    ConnectComPort();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::COM41Click(TObject *Sender)
{
    TMenuItem *item;
    int i;

    for(i=0;i<MainMenu->Items[0].Items[1]->Count;i++) MainMenu->Items[0].Items[1]->Items[i]->Checked = false;

    item = MainMenu->Items[0].Items[1]->Find("COM4");
    if(item == NULL) return;
    item->Checked = true;
    CommPortDriver->Disconnect();
    CommPortDriver->Port = pnCOM4;
    ConnectComPort();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormShow(TObject *Sender)
{
    ConnectComPort();

    int i,j,k;

    for(i=0;i<26;i++) {
        ListBox->Items->Add(AnsiString(char('A'+i))+AnsiString(":"));
        ComboBox1->Items->Add(AnsiString(char('A'+i)));
        ComboBox8->Items->Add(AnsiString(char('A'+i)));
    }
    ComboBox1->Items->Add("No Show");
    ComboBox1->ItemIndex = 26;
    ComboBox6->ItemIndex = 0;
    ComboBox8->ItemIndex = 0;

    PlaylistStringGrid->ColWidths[1] = 60;
    PlaylistStringGrid->ColWidths[2] = 120;
    PlaylistStringGrid->ColWidths[3] = 200;
    PlaylistStringGrid->ColWidths[4] = 200;
    for(i=1;i<=100;i++) PlaylistStringGrid->Cells[0][i] = AnsiString(i);

    PlaylistStringGrid->Cells[1][0] = "Show";
    PlaylistStringGrid->Cells[2][0] = "Timing";
    PlaylistStringGrid->Cells[3][0] = "Start";
    PlaylistStringGrid->Cells[4][0] = "Stop";

    for(i=0;i<101;i++) ComboBox7->Items->Add(i);
    ComboBox7->Items->Add("Forever");

    DateTimePicker1->Time.FormatString("hh:mm:ss");
    DateTimePicker2->Time.FormatString("hh:mm:ss");

    for(i=1;i<=32;i++) {
       for(j=1;j<=16;j++) {
           StringGrid->Cells[j][i]=0;
       }
    }

    for(j=1;j<=16;j++) {
       StringGrid->Cells[j][0]=j;
    }

    for(j=1;j<=32;j++) {
       StringGrid->Cells[0][j]=(j-1)*16;
    }


    update_playlist_grid();

}

//---------------------------------------------------------------------------

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
    CommPortDriver->Disconnect();
}
//---------------------------------------------------------------------------


void TForm1::ConnectComPort(void)
{
     if(CommPortDriver->Connected())  CommPortDriver->Disconnect();
     if(CommPortDriver->Connect() == false) {
        Application->MessageBox("Could not open COM port","Error",MB_OK	);
    }
}
void __fastcall TForm1::BitBtn3Click(TObject *Sender)
{

    int i;
    int index = 0;

    ConnectComPort();
    if(!CommPortDriver->Connected()) return;

    CommPortDriver->FlushBuffers(true,true);

    for(i='A';i<='Z';i++) {
        CommPortDriver->SendByte('E');
        CommPortDriver->SendByte('3');
        CommPortDriver->SendByte(i);
        int res;
        res = CommPortDriver->ReadData((char *)&show_struct[index],sizeof(ShowStruct));
        if(res != sizeof(ShowStruct)) {
            Application->MessageBox("Communication Error","Error",MB_OK	);
            return;
        }
        // terminate the string;
        show_struct[index].ShowName[15] = 0;
        index++;
    }
    CheckListBox1->Items->Clear();
    for(i=0;i<26;i++) {
        if(show_struct[i].NumFrames == 0) CheckListBox1->Items->Add(AnsiString((char)(i+'A')) + ":" + AnsiString("EMPTY"));
        else CheckListBox1->Items->Add(AnsiString((char)(i+'A')) + ":" + AnsiString(show_struct[i].ShowName));
    }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::BitBtn1Click(TObject *Sender)
{
    int i;

    if(OpenDirectory->Execute() == false) return;

    change_coms_speed(115200);
    for(i=0;i<26;i++) {
        if(CheckListBox1->Checked[i] == true) {
            StatusBar->SimpleText = AnsiString("Saving :") + Trim(show_struct[i].ShowName);
            if(save_show(i,OpenDirectory->DrivePath)) {
                change_coms_speed(9600);
                ProgressBar->Position = 0;
                return;
            }
        }
    }
    change_coms_speed(9600);
    StatusBar->SimpleText = "Done";
    ProgressBar->Position = 0;
}
//---------------------------------------------------------------------------


bool TForm1::save_show(int index,AnsiString location)
{
    int start;
    int size;
    int i;
    int ret = false;
    unsigned char buffer[600];

    TFileStream *file = new TFileStream(location +AnsiString("\\")+ Trim(AnsiString(show_struct[index].ShowName)) + AnsiString(".shw"),fmCreate);
    file->Write(&show_struct[index],sizeof(ShowStruct));
    delete file;

    file = new TFileStream(location +AnsiString("\\")+  Trim(AnsiString(show_struct[index].ShowName)) + AnsiString(".dat"),fmCreate);

    CommPortDriver->FlushBuffers(true,true);

    CommPortDriver->SendByte('E');
    CommPortDriver->SendByte('5');
    CommPortDriver->SendByte(index + 'A');

    start = 0;
    buffer[0] =  start >> 24;
    buffer[1] =  start >> 16;
    buffer[2] =  start >> 8;
    buffer[3] =  start;
    CommPortDriver->SendData(buffer,4);

    size = show_struct[index].NumFrames;
    buffer[0] =  size >> 24;
    buffer[1] =  size >> 16;
    buffer[2] =  size >> 8;
    buffer[3] =  size;
    CommPortDriver->SendData(buffer,4);

    ProgressBar->Max = show_struct[index].NumFrames;
    ProgressBar->Step = show_struct[index].NumFrames/10;
    ProgressBar->Position = 0;

    TCursor Save_Cursor = Screen->Cursor;

    Screen->Cursor = crHourGlass;    // Show hourglass cursor

    int res;
    for(i=0;i<show_struct[index].NumFrames;i++) {
        res = CommPortDriver->ReadData(buffer,show_struct[index].NumChannels+sizeof(FrameHeader));
        if(res != show_struct[index].NumChannels+sizeof(FrameHeader)) {
            Application->MessageBox("Communication Error","Error",MB_OK	);
            ret = true;
            break;
        }
        file->Write(buffer,show_struct[index].NumChannels+sizeof(FrameHeader));
        ProgressBar->Position = i;
    }
    delete file;
    Screen->Cursor = Save_Cursor; // always restore the cursor

    return ret;
}

bool TForm1::change_coms_speed(int speed)
{
    unsigned char buffer[4];
    int res;

    CommPortDriver->SendByte('R');
    if(speed == 115200) {
        CommPortDriver->SendByte('B');
        res = CommPortDriver->ReadByte(buffer[0]);
        if((res == 0) || (buffer[0] != '!')) return true;
        CommPortDriver->BaudRate = br115200;
    }
    else {
        CommPortDriver->SendByte('A');
        res = CommPortDriver->ReadByte(buffer[0]);
        if((res == 0) || (buffer[0] != '!')) return true;
        CommPortDriver->BaudRate = br9600;


    }
    res = CommPortDriver->ReadData(buffer,3);
    if((res == 0) || (buffer[0] != '!')) return true;

    return false;


}
void __fastcall TForm1::ListBoxDblClick(TObject *Sender)
{
    int i;
    for(i=0;i<26;i++){
        if(ListBox->Selected[i]) break;
    }
    if(i==26) return;
    OpenDialog->FileName= "*.shw";
    if(OpenDialog->Execute()) {
        ListBox->Items->Strings[i]= AnsiString(char('A'+i))+AnsiString(":") + OpenDialog->FileName;
    }

}
//---------------------------------------------------------------------------



bool TForm1::restore_show(int index)
{
    int start;
    int size;
    int i;
    int res = false;
    unsigned char buffer[600];
    AnsiString name;
    unsigned char *data_ptr;

    name = ListBox->Items->Strings[index].SubString(3,100);

    TFileStream *file = new TFileStream(name,fmOpenRead);
    file->Read(&show_struct[index],sizeof(ShowStruct));
    delete file;

    CommPortDriver->FlushBuffers(true,true);

    CommPortDriver->SendByte('E');
    CommPortDriver->SendByte('2');
    CommPortDriver->SendByte(index + 'A');

    // empty the show
    show_struct[index].FirstFrameSector = 0xFFFF;

    data_ptr = (unsigned char *)&show_struct[index];

    for(i=0;i<sizeof(ShowStruct);i++) {
        CommPortDriver->SendByte(*data_ptr);
        res = CommPortDriver->ReadByte(buffer[0]);
        if((res == 0) || (buffer[0] != '!')) {
            Application->MessageBox("Communication Error","Error",MB_OK	);
            delete file;
            return true;
        }
        data_ptr++;
    }

    CommPortDriver->FlushBuffers(true,true);

    name = name.SetLength(name.Length()-3) + AnsiString("dat");
    file = new TFileStream(name,fmOpenRead);


    ProgressBar->Max = show_struct[index].NumFrames;
    ProgressBar->Step = show_struct[index].NumFrames/10;
    ProgressBar->Position = 0;

    CommPortDriver->SendByte('E');
    CommPortDriver->SendByte('4');
    CommPortDriver->SendByte(index + 'A');

    res = CommPortDriver->ReadByte(buffer[0]);
    if((res == 0) || (buffer[0] != '!')) {
        Application->MessageBox("Communication Error","Error",MB_OK	);
        delete file;
        return true;
    }
    for(i=0;i<show_struct[index].NumFrames;i++) {
        file->Read(buffer,sizeof(FrameHeader));
        CommPortDriver->SendData(buffer,sizeof(FrameHeader));
        file->Read(buffer,show_struct[index].NumChannels);
        CommPortDriver->SendData(buffer,show_struct[index].NumChannels);

        res = CommPortDriver->ReadByte(buffer[0]);
        if((res == 0) || (buffer[0] != '!')) {
            Application->MessageBox("Communication Error","Error",MB_OK	);
            delete file;
            return true;
        }
        ProgressBar->Position = i;
    }

    delete file;
    return false;

}
void __fastcall TForm1::BitBtn2Click(TObject *Sender)
{
    int i;

    change_coms_speed(115200);
    for(i=0;i<26;i++) {
        if(ListBox->Items->Strings[i] != (AnsiString(char('A'+i))+AnsiString(":"))) {
            StatusBar->SimpleText = AnsiString("Restoring :") + ListBox->Items->Strings[i];
            if(restore_show(i)) {
                change_coms_speed(9600);
                return;
            }
        }
    }
    change_coms_speed(9600);
    StatusBar->SimpleText = "Done";
}
//---------------------------------------------------------------------------




void __fastcall TForm1::BitBtn4Click(TObject *Sender)
{
    int i;

    for(i=0;i<26;i++) {
        ListBox->Items->Clear();
    }

    for(i=0;i<26;i++) {
        ListBox->Items->Add(AnsiString(char('A'+i))+AnsiString(":"));
    }
}
//---------------------------------------------------------------------------


void __fastcall TForm1::BitBtn6Click(TObject *Sender)
{
    int i;
    char rom_file_record[15];
    int word_address_out;
    int prev_word_address_out = -1;
    int word_value_out;
    unsigned short checksum = 0;

    if(OpenDialog1->Execute() == false) return;
    Edit1->Text = OpenDialog1->FileName;

    TStringList *file = new TStringList;
    file->LoadFromFile(Edit1->Text);
    for(i=0;i<file->Count;i++) {
        strcpy(rom_file_record,file->Strings[i].c_str());
        rom_file_record[6]=0;
        if (sscanf(rom_file_record,"%6x",&word_address_out) == -1) {
        }
        if(prev_word_address_out!=-1) {
            if(word_address_out != prev_word_address_out+1) {
                Application->MessageBox("Invalid ROM File","Error",MB_OK);
                Edit1->Text = "";
                delete file;
                return;
            }
        }
        prev_word_address_out = word_address_out;
        if (sscanf(&(rom_file_record[7]),"%4x",&word_value_out) == -1) {
        }
        checksum += word_value_out;
    }

    sprintf(rom_file_record,"0x%04x",checksum);
    //Edit2->Text = rom_file_record;
    delete file;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BitBtn5Click(TObject *Sender)
{
    TStringList *file = new TStringList;
    AnsiString string;
    char buffer[80];
    int i;
    int res;

    if(Edit1->Text == "")  return;

    if(BitBtn5->Caption == "Stop") {
        cancel_boot = true;
        return;
    }

    cancel_boot = false;

    file->LoadFromFile(Edit1->Text);

    CommPortDriver->BaudRate = br57600;

    BitBtn5->Caption = "Stop";

    StatusBar->SimpleText = "Waiting for DMXStreamer ...";
    got_boot_msg = false;
    boot_msg_err = false;

    CommPortDriver->PacketSize = 27;

    while(got_boot_msg == false) {
        Application->ProcessMessages();
        if(boot_msg_err) {
            Application->MessageBox("Communication Error","Error",MB_OK	);
        }
        if(boot_msg_err || cancel_boot) {
            BitBtn5->Caption = "Activate";
            StatusBar->SimpleText = "";
            delete file;
            CommPortDriver->BaudRate = br9600;
            return;
        }
    }

    CommPortDriver->FlushBuffers(true,true);
    BmDelay1->WaitForDelay(2000);

    StatusBar->SimpleText = "Sending new firmware";

    ProgressBar->Max = file->Count;
    ProgressBar->Step = file->Count/10;
    ProgressBar->Position = 0;
    res = CommPortDriver->OutFreeSpace();

    for(i=0;i<file->Count;i++) {
        while(res!=CommPortDriver->OutFreeSpace());
        Application->ProcessMessages();
        strcpy(buffer,file->Strings[i].c_str());
        CommPortDriver->SendData(buffer,strlen(buffer));
//        Label6->Caption = buffer;
        // add line feed and CR
        CommPortDriver->SendByte(0x0D);
        CommPortDriver->SendByte(0x0A);
        ProgressBar->Position = i;
        if(cancel_boot == true) {
            ProgressBar->Position = 0;
            break;
        }
    }

    StatusBar->SimpleText = "Done";

    delete file;
    CommPortDriver->PacketSize = -1;
    BitBtn5->Caption = "Activate";
    CommPortDriver->BaudRate = br9600;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CommPortDriverReceivePacket(TObject *Sender,
      Pointer Packet, DWORD DataSize)
{
    if((DataSize != 27)||(StrPos((char *)Packet,"Waiting to receive")==NULL)) {
        boot_msg_err = true;
    }
    else {
        got_boot_msg = true;
    }
}
//---------------------------------------------------------------------------




bool TForm1::get_playlist(int playlist)
{
    int i;

    CommPortDriver->SendByte('E');
    CommPortDriver->SendByte('6');
    CommPortDriver->SendByte(playlist);
    int res;
    res = CommPortDriver->ReadData((char *)&play_list_entries[playlist],sizeof(PlaylistStruct));
    if(res != sizeof(PlaylistStruct)) {
        Application->MessageBox("Communication Error","Error",MB_OK	);
        return true;
    }

    return false;
}
void __fastcall TForm1::BitBtn9Click(TObject *Sender)
{
    int i;

    ProgressBar->Max = 100;
    ProgressBar->Step = 10;
    ProgressBar->Position = 0;

    //change_coms_speed(115200);

    for(i=0;i<100;i++) {
        if(get_playlist(i)) {
            change_coms_speed(9600);
            return;
        }
        ProgressBar->Position = i;
    }
    update_playlist_grid();
    change_coms_speed(9600);
    BitBtn10->Enabled = true;
}
//---------------------------------------------------------------------------


void TForm1::update_playlist_grid(void)
{
    int i;
    PlaylistStruct *play_list_ptr;
    char buffer[80];

    for(i=0;i<100;i++) {
        play_list_ptr = &play_list_entries[i];
        if(play_list_ptr->ShowNum == 0xFF) {
            PlaylistStringGrid->Cells[1][i+1] = "No Show";
            PlaylistStringGrid->Cells[2][i+1] = "";
            PlaylistStringGrid->Cells[3][i+1] = "";
            PlaylistStringGrid->Cells[4][i+1] = "";
            continue;
        }
        else PlaylistStringGrid->Cells[1][i+1] = AnsiString(char('A'+play_list_ptr->ShowNum));
        switch(play_list_ptr->TimingFormat) {
            case 0: {
                PlaylistStringGrid->Cells[2][i+1] = "Looped Auto Play";
                if(play_list_ptr->StartTime.DayOfWeek != 8) {
                    sprintf(buffer,"%02d:%02d:%02d %s ",play_list_ptr->StartTime.Hour,play_list_ptr->StartTime.Min,
                    play_list_ptr->StartTime.Sec,DAY_OF_WEEK_ARRAY[play_list_ptr->StartTime.DayOfWeek]);
                }
                else {
                    // special event
                    sprintf(buffer,"%02d:%02d:%02d %s %d/%d ",play_list_ptr->StartTime.Hour,play_list_ptr->StartTime.Min,
                    play_list_ptr->StartTime.Sec,DAY_OF_WEEK_ARRAY[play_list_ptr->StartTime.DayOfWeek],play_list_ptr->StartTime.Day,play_list_ptr->StartTime.Month );

                }

                strcat(buffer,KIND_OF_TIME_ARRAY[play_list_ptr->StartTime.KindOfTime]);

                PlaylistStringGrid->Cells[3][i+1] = buffer;
                if(play_list_ptr->LoopTimes == LOOP_FOREVER) PlaylistStringGrid->Cells[4][i+1] = "Loop forever";
                else PlaylistStringGrid->Cells[4][i+1] = AnsiString("Loop ")+ AnsiString(play_list_ptr->LoopTimes)+AnsiString(" times");
            }break;
            case 1: {
                PlaylistStringGrid->Cells[2][i+1] = "Timed Auto Play";
                if(play_list_ptr->StartTime.DayOfWeek != 8) {
                    sprintf(buffer,"%02d:%02d:%02d %s",play_list_ptr->StartTime.Hour,play_list_ptr->StartTime.Min,
                    play_list_ptr->StartTime.Sec,DAY_OF_WEEK_ARRAY[play_list_ptr->StartTime.DayOfWeek]);
                }
                else {
                    // special event
                    sprintf(buffer,"%02d:%02d:%02d %s %d/%d",play_list_ptr->StartTime.Hour,play_list_ptr->StartTime.Min,
                    play_list_ptr->StartTime.Sec,DAY_OF_WEEK_ARRAY[play_list_ptr->StartTime.DayOfWeek],play_list_ptr->StartTime.Day,play_list_ptr->StartTime.Month );

                }
                strcat(buffer,KIND_OF_TIME_ARRAY[play_list_ptr->StartTime.KindOfTime]);
                PlaylistStringGrid->Cells[3][i+1] = buffer;

                if(play_list_ptr->EndTime.DayOfWeek != 8) {
                    sprintf(buffer,"%02d:%02d:%02d %s",play_list_ptr->EndTime.Hour,play_list_ptr->EndTime.Min,
                    play_list_ptr->EndTime.Sec,DAY_OF_WEEK_ARRAY[play_list_ptr->EndTime.DayOfWeek]);
                }
                else {
                    // special event
                    sprintf(buffer,"%02d:%02d:%02d %s %d/%d",play_list_ptr->EndTime.Hour,play_list_ptr->EndTime.Min,
                    play_list_ptr->EndTime.Sec,DAY_OF_WEEK_ARRAY[play_list_ptr->EndTime.DayOfWeek],play_list_ptr->EndTime.Day,play_list_ptr->EndTime.Month );

                }

                strcat(buffer,KIND_OF_TIME_ARRAY[play_list_ptr->EndTime.KindOfTime]);
                PlaylistStringGrid->Cells[4][i+1] = buffer;
            }break;
            case 2: {
                PlaylistStringGrid->Cells[2][i+1] = "Power On";
                PlaylistStringGrid->Cells[3][i+1] = "";
                if(play_list_ptr->LoopTimes == LOOP_FOREVER) PlaylistStringGrid->Cells[4][i+1] = "Loop forever";
                else PlaylistStringGrid->Cells[4][i+1] = AnsiString("Loop ")+ AnsiString(play_list_ptr->LoopTimes)+AnsiString(" times");
            }break;
            case 3: {
                PlaylistStringGrid->Cells[2][i+1] = "Switch Closure";
                PlaylistStringGrid->Cells[3][i+1] = "";
                if(play_list_ptr->LoopTimes == LOOP_FOREVER) PlaylistStringGrid->Cells[4][i+1] = "Loop forever";
                else PlaylistStringGrid->Cells[4][i+1] = AnsiString("Loop ")+ AnsiString(play_list_ptr->LoopTimes)+AnsiString(" times");
            }break;

            case 4: {
                PlaylistStringGrid->Cells[2][i+1] = "Remote Command";
                PlaylistStringGrid->Cells[3][i+1] = "";
                if(play_list_ptr->LoopTimes == LOOP_FOREVER) PlaylistStringGrid->Cells[4][i+1] = "Loop forever";
                else PlaylistStringGrid->Cells[4][i+1] = AnsiString("Loop ")+ AnsiString(play_list_ptr->LoopTimes)+AnsiString(" times");
            }break;

            case 5: {
                 //seasons
                 PlaylistStringGrid->Cells[1][i+1] = "Seasons Entry";
            }
        }


//        PlaylistStringGrid->Cells[3][0] = "Start";
//        PlaylistStringGrid->Cells[4][0] = "Stop";

    }
}


void __fastcall TForm1::PlaylistStringGridSelectCell(TObject *Sender,
      int ACol, int ARow, bool &CanSelect)
{
    CanSelect = true;
    PlaylistStruct *play_list_ptr;

    selected_playlist_entry = ARow-1;

    play_list_ptr = &play_list_entries[selected_playlist_entry];

    if(play_list_ptr->ShowNum == 0xFF) ComboBox1->ItemIndex = 26;
    else ComboBox1->ItemIndex = play_list_ptr->ShowNum;

    if(play_list_ptr->TimingFormat == 5) {
        Application->MessageBoxA("Seasons cannot be edited from Streamer utilities","Warning",MB_OK);
        return;
    }

    ComboBox2->ItemIndex = play_list_ptr->TimingFormat;
    ComboBox3->ItemIndex = play_list_ptr->StartTime.KindOfTime;
    ComboBox4->ItemIndex = play_list_ptr->StartTime.DayOfWeek;
    ComboBox5->ItemIndex = play_list_ptr->EndTime.DayOfWeek;
    ComboBox6->ItemIndex = play_list_ptr->EndTime.KindOfTime;

    update_playlist_edit_tab(play_list_ptr);


}
//---------------------------------------------------------------------------


void __fastcall TForm1::PlayListEditChange(TObject *Sender)
{
    PlaylistStruct *play_list_ptr;
    unsigned short h,m,s,i;
    unsigned short year,month,day;

    play_list_ptr = &play_list_entries[selected_playlist_entry];

    if(ComboBox1->ItemIndex == 26) play_list_ptr->ShowNum = 255;
    else play_list_ptr->ShowNum = ComboBox1->ItemIndex;
    play_list_ptr->TimingFormat = ComboBox2->ItemIndex;
    play_list_ptr->LoopTimes =  ComboBox7->ItemIndex;
    play_list_ptr->StartTime.DayOfWeek = ComboBox4->ItemIndex;
    if(play_list_ptr->StartTime.DayOfWeek == 255) play_list_ptr->StartTime.DayOfWeek = 0;
    DateTimePicker1->Time.DecodeTime(&h,&m,&s,&i);
    play_list_ptr->StartTime.Hour = h;
    play_list_ptr->StartTime.Min = m;
    play_list_ptr->StartTime.Sec = s;

    play_list_ptr->StartTime.KindOfTime = ComboBox3->ItemIndex;
    if(play_list_ptr->StartTime.KindOfTime > 4) play_list_ptr->StartTime.KindOfTime = 0;



    DateTimePicker3->Time.DecodeDate(&year,&month,&day);
    play_list_ptr->StartTime.Day = day;
    play_list_ptr->StartTime.Month = month;

    play_list_ptr->EndTime.DayOfWeek = ComboBox5->ItemIndex;
    if(play_list_ptr->EndTime.DayOfWeek == 255) play_list_ptr->EndTime.DayOfWeek = 0;
    DateTimePicker2->Time.DecodeTime(&h,&m,&s,&i);
    play_list_ptr->EndTime.Hour = h;
    play_list_ptr->EndTime.Min = m;
    play_list_ptr->EndTime.Sec = s;

    DateTimePicker4->Time.DecodeDate(&year,&month,&day);
    play_list_ptr->EndTime.Day = day;
    play_list_ptr->EndTime.Month = month;
    play_list_ptr->EndTime.KindOfTime =  ComboBox6->ItemIndex;


    update_playlist_grid();
    update_playlist_edit_tab(play_list_ptr);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::TabSheet3Show(TObject *Sender)
{
//    PageControl1->Pages[2]->Visible = false;
}
//---------------------------------------------------------------------------


void TForm1::update_playlist_edit_tab(PlaylistStruct *play_list_ptr)
{
    switch(play_list_ptr->TimingFormat) {
        case 0: { // looped auto play
            ComboBox7->Enabled = true;
            ComboBox7->Color = clWindow;
             DateTimePicker2->Enabled = false;
            DateTimePicker2->Color = clInactiveBorder;
            ComboBox5->Enabled = false;
            ComboBox5->Color = clInactiveBorder;
            ComboBox6->Enabled = false;
            ComboBox6->Color = clInactiveBorder;
            DateTimePicker1->Enabled = true;
            DateTimePicker1->Color = clWindow;
            ComboBox4->Enabled = true;
            ComboBox4->Color = clWindow;
            ComboBox3->Enabled = true;
            ComboBox3->Color = clWindow;
            if(play_list_ptr->ShowNum != 0xFF) {
                TDateTime time(play_list_ptr->StartTime.Hour,play_list_ptr->StartTime.Min,
                play_list_ptr->StartTime.Sec,0);
                DateTimePicker1->Time = time.FormatString("hh:mm:ss");
                ComboBox4->ItemIndex = play_list_ptr->StartTime.DayOfWeek;
            }
        }break;
        case 1: { // timed auto play
            ComboBox7->Enabled = false;
            ComboBox7->Color = clInactiveBorder;
            DateTimePicker1->Enabled = true;
            DateTimePicker1->Color = clWindow;
            DateTimePicker2->Enabled = true;
            DateTimePicker2->Color = clWindow;
            ComboBox3->Enabled = true;
            ComboBox3->Color = clWindow;
            ComboBox4->Enabled = true;
            ComboBox4->Color = clWindow;
            ComboBox5->Enabled = true;
            ComboBox5->Color = clWindow;
            ComboBox6->Enabled = true;
            ComboBox6->Color = clWindow;
            if(play_list_ptr->ShowNum != 0xFF) {
                TDateTime time(play_list_ptr->StartTime.Hour,play_list_ptr->StartTime.Min,
                play_list_ptr->StartTime.Sec,0);
                DateTimePicker1->Time = time.FormatString("hh:mm:ss");
                ComboBox4->ItemIndex = play_list_ptr->StartTime.DayOfWeek;

                TDateTime time2(play_list_ptr->EndTime.Hour,play_list_ptr->EndTime.Min,
                play_list_ptr->EndTime.Sec,0);
                DateTimePicker2->Time = time2.FormatString("hh:mm:ss");
                ComboBox5->ItemIndex = play_list_ptr->EndTime.DayOfWeek;
            }
        }break;
        case 2: { // power on
            ComboBox7->Enabled = true;
            ComboBox7->Color = clWindow;
            DateTimePicker1->Enabled = false;
            DateTimePicker1->Color = clInactiveBorder;
            DateTimePicker2->Enabled = false;
            DateTimePicker2->Color = clInactiveBorder;
            ComboBox3->Enabled = false;
            ComboBox3->Color = clInactiveBorder;
            ComboBox4->Enabled = false;
            ComboBox4->Color = clInactiveBorder;
            ComboBox5->Enabled = false;
            ComboBox5->Color = clInactiveBorder;
            ComboBox6->Enabled = false;
            ComboBox6->Color = clInactiveBorder;
            ComboBox7->ItemIndex = play_list_ptr->LoopTimes;

        }break;
        case 3: { //switch
            ComboBox7->Enabled = true;
            ComboBox7->Color = clWindow;
            DateTimePicker1->Enabled = false;
            DateTimePicker1->Color = clInactiveBorder;
            DateTimePicker2->Enabled = false;
            DateTimePicker2->Color = clInactiveBorder;
            ComboBox3->Enabled = false;
            ComboBox3->Color = clInactiveBorder;
            ComboBox4->Enabled = false;
            ComboBox4->Color = clInactiveBorder;
            ComboBox5->Enabled = false;
            ComboBox5->Color = clInactiveBorder;
            ComboBox6->Enabled = false;
            ComboBox6->Color = clInactiveBorder;
            ComboBox7->ItemIndex = play_list_ptr->LoopTimes;
        }break;
         case 4: { //remoet
            ComboBox7->Enabled = true;
            ComboBox7->Color = clWindow;
            DateTimePicker1->Enabled = false;
            DateTimePicker1->Color = clInactiveBorder;
            DateTimePicker2->Enabled = false;
            DateTimePicker2->Color = clInactiveBorder;
            ComboBox3->Enabled = false;
            ComboBox3->Color = clInactiveBorder;
            ComboBox4->Enabled = false;
            ComboBox4->Color = clInactiveBorder;
            ComboBox5->Enabled = false;
            ComboBox5->Color = clInactiveBorder;
            ComboBox6->Enabled = false;
            ComboBox6->Color = clInactiveBorder;
            ComboBox7->ItemIndex = play_list_ptr->LoopTimes;
        }break;


    }

    // Hide unused dates
    if(ComboBox4->Text == "Special") {
        DateTimePicker3->Enabled = true;
        DateTimePicker3->Visible = true;
        DateTimePicker3->Color = clWindow;
    }
    else {
         DateTimePicker3->Enabled = false;
         DateTimePicker3->Visible = false;
         DateTimePicker3->Color = clInactiveBorder;
    }

    if(ComboBox5->Text == "Special") {
        DateTimePicker4->Enabled = true;
        DateTimePicker4->Visible = true;
        DateTimePicker4->Color = clWindow;
    }
    else {
         DateTimePicker4->Enabled = false;
         DateTimePicker4->Visible = false;
         DateTimePicker4->Color = clInactiveBorder;
    }
}

void __fastcall TForm1::BitBtn7Click(TObject *Sender)
{

    if(SaveDialog1->Execute() == false) return;

    TFileStream *file = new TFileStream(SaveDialog1->FileName,fmCreate);
    file->Write(play_list_entries,sizeof(PlaylistStruct)*100);
    delete file;
    StatusBar->SimpleText = "Done";

}
//---------------------------------------------------------------------------


void __fastcall TForm1::BitBtn8Click(TObject *Sender)
{

    if(OpenDialog2->Execute() == false) return;

    TFileStream *file = new TFileStream(OpenDialog2->FileName,fmOpenRead);
    file->Read(play_list_entries,sizeof(PlaylistStruct)*100);
    delete file;

    update_playlist_grid();
    StatusBar->SimpleText = "Done";
    BitBtn10->Enabled = true;
}
//---------------------------------------------------------------------------


void __fastcall TForm1::BitBtn11Click(TObject *Sender)
{
    ShowStruct view_show_struct;

    if(OpenDialog->Execute() == false) return;
    Edit2->Text = OpenDialog->FileName;

    TFileStream *file = new TFileStream(Edit2->Text,fmOpenRead);
    file->Read(&view_show_struct,sizeof(ShowStruct));
    delete file;

    Edit3->Text = view_show_struct.ShowName;
    Edit4->Text = view_show_struct.FrameRate;
    Edit5->Text = view_show_struct.NumChannels;
    Edit6->Text = view_show_struct.NumFrames;
    Edit7->Text = view_show_struct.NumFrames * (sizeof(FrameHeader)+view_show_struct.NumChannels);
    Edit15->Text = view_show_struct.CrossFadeTime;

    ScrollBar1->Max = view_show_struct.NumFrames-1;
    ScrollBar1->Position = 1;
    ScrollBar1->Position = 0;



}
//---------------------------------------------------------------------------

void __fastcall TForm1::ScrollBar1Change(TObject *Sender)
{
    int i,j,k;
    int c;
    AnsiString str;
    unsigned char data[512];
    FrameHeader frame_head;
    float time;

    Edit8->Text = ScrollBar1->Position;

    if(Edit6->Text == "") return;

    memset(data,0,512);

    TFileStream *file = new TFileStream(Edit2->Text.SubString(1,Edit2->Text.Length()-4) + AnsiString(".dat"),fmOpenRead);
    file->Seek(ScrollBar1->Position*(Edit5->Text.ToInt()+sizeof(FrameHeader)),soFromBeginning);
    file->Read(&frame_head,sizeof(FrameHeader));
    file->Read(&data,Edit5->Text.ToInt());
    delete file;

    time =frame_head.TimeStamp;
    Edit9->Text = time/100;

    c=0;
    for(i=1;i<=32;i++) {
        for(j=1;j<=16;j++) {
            c=(i-1)*16+(j-1);
            k=data[c];
            StringGrid->Cells[j][i]=k;
        }
    }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit8Change(TObject *Sender)
{
    ScrollBar1->Position = Edit8->Text.ToInt();
}
//---------------------------------------------------------------------------


bool TForm1::set_playlist(int playlist)
{
    int i;
    unsigned char *data_ptr = (char *)&play_list_entries[playlist];
    unsigned char buf;

    CommPortDriver->SendByte('E');
    CommPortDriver->SendByte('7');
    CommPortDriver->SendByte(playlist);
    int res;

    CommPortDriver->FlushBuffers(true,true);

    for(i=0;i<sizeof(PlaylistStruct);i++) {
        CommPortDriver->SendByte(*data_ptr);
        res = CommPortDriver->ReadByte(buf);
        if((res == 0) || (buf != '!')) {
            Application->MessageBox("Communication Error","Error",MB_OK	);
            return true;
        }
        data_ptr++;
    }

    return false;
}
void __fastcall TForm1::BitBtn10Click(TObject *Sender)
{
    int i;

    ProgressBar->Max = 100;
    ProgressBar->Step = 10;
    ProgressBar->Position = 0;

    change_coms_speed(115200);

    for(i=0;i<100;i++) {
        if(set_playlist(i)) {
            change_coms_speed(9600);
            return;
        }
        ProgressBar->Position = i;
    }
    change_coms_speed(9600);
}
//---------------------------------------------------------------------------


void __fastcall TForm1::SpeedButton1Click(TObject *Sender)
{
    Edit10->Text = ScrollBar1->Position;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton2Click(TObject *Sender)
{
    Edit11->Text = ScrollBar1->Position;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
    int i,j,k;
    int frames = 0;
    unsigned char data[512];
    FrameHeader frame_head;
    float time;
    int start, stop;
    ShowStruct view_show_struct;

    start  = Edit10->Text.ToInt();
    stop  = Edit11->Text.ToInt();

    if(start > stop) {
        i = stop;
        stop = start;
        start = i;
    }

    if(Edit6->Text == "") return;

    TCursor Save_Cursor = Screen->Cursor;
    Screen->Cursor = crHourGlass;    // Afficher le curseur Sablier

    ProgressBar->Max = Edit6->Text.ToInt();
    ProgressBar->Step = Edit6->Text.ToInt()/10;
    ProgressBar->Position = 0;


    memset(data,0,512);

    TFileStream *file = new TFileStream(Edit2->Text.SubString(1,Edit2->Text.Length()-4) + AnsiString(".dat"),fmOpenRead);
    TFileStream *new_file = new TFileStream(Edit2->Text.SubString(1,Edit2->Text.Length()-4) +AnsiString("_new") +AnsiString(".dat"),fmCreate);
    file->Seek(0,soFromBeginning);

    for(i=0;i<Edit6->Text.ToInt();i++) {
        file->Read(&frame_head,sizeof(FrameHeader));
        file->Read(&data,Edit5->Text.ToInt());
         ProgressBar->Position = i;
        // skip the un wanted frames
        if((i >= start) && (i<=stop)) continue;

        new_file->Write(&frame_head,sizeof(FrameHeader));
        new_file->Write(&data,Edit5->Text.ToInt());
        frames++;

    }

    delete file;
    delete new_file;

    file = new TFileStream(Edit2->Text,fmOpenRead);
    file->Read(&view_show_struct,sizeof(ShowStruct));

    view_show_struct.NumFrames = frames;

    new_file = new TFileStream(Edit2->Text.SubString(1,Edit2->Text.Length()-4) +AnsiString("_new") +AnsiString(".shw"),fmCreate);
    new_file->Write(&view_show_struct,sizeof(ShowStruct));

    delete file;
    delete new_file;

    AnsiString str;
    str =AnsiString("New file saved as ") + Edit2->Text.SubString(1,Edit2->Text.Length()-4) +AnsiString("_new") +AnsiString(".shw");
    Application->MessageBox(str.c_str(),"Done",MB_OK);

    Screen->Cursor = Save_Cursor;


}
//---------------------------------------------------------------------------


void __fastcall TForm1::BitBtn12Click(TObject *Sender)
{
    if(OpenDialog3->Execute() == false) return;
    Edit12->Text = OpenDialog3->FileName;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BitBtn13Click(TObject *Sender)
{
    TStringList *file = new TStringList;
    AnsiString string;
    char buffer[80];
    int i;
    int res;

    if(Edit12->Text == "")  return;

    if(BitBtn13->Caption == "Stop") {
        cancel_boot = true;
        return;
    }

    cancel_boot = false;

    file->LoadFromFile(Edit12->Text);

    CommPortDriver->BaudRate = br57600;

    BitBtn13->Caption = "Stop";

    StatusBar->SimpleText = "Waiting for DMXStreamer ...";
    got_boot_msg = false;
    boot_msg_err = false;

    CommPortDriver->PacketSize = 27;

    while(got_boot_msg == false) {
        Application->ProcessMessages();
        if(boot_msg_err) {
            Application->MessageBox("Communication Error","Error",MB_OK	);
        }
        if(boot_msg_err || cancel_boot) {
            BitBtn13->Caption = "Activate";
            StatusBar->SimpleText = "";
            delete file;
            CommPortDriver->BaudRate = br9600;
            return;
        }
    }

    CommPortDriver->FlushBuffers(true,true);
    BmDelay1->WaitForDelay(2000);

    StatusBar->SimpleText = "Sending new firmware";

    ProgressBar->Max = file->Count;
    ProgressBar->Step = file->Count/10;
    ProgressBar->Position = 0;
    res = CommPortDriver->OutFreeSpace();

    for(i=0;i<file->Count;i++) {
        while(res!=CommPortDriver->OutFreeSpace());
        Application->ProcessMessages();
        strcpy(buffer,file->Strings[i].c_str());
        CommPortDriver->SendData(buffer,strlen(buffer));
//        Label6->Caption = buffer;
        // add line feed and CR
        CommPortDriver->SendByte(0x0D);
        CommPortDriver->SendByte(0x0A);
        ProgressBar->Position = i;
        if(cancel_boot == true) {
            ProgressBar->Position = 0;
            break;
        }
    }

    StatusBar->SimpleText = "Done";

    delete file;
    CommPortDriver->PacketSize = -1;
    BitBtn13->Caption = "Activate";
    CommPortDriver->BaudRate = br9600;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ComboBox8Change(TObject *Sender)
{
    int i;
    int show_id;

    i = ComboBox8->ItemIndex;
    if((i<0)||(i>25)) i =0;
    show_id = i+'A';

    CommPortDriver->SendByte('E');
    CommPortDriver->SendByte('3');
    CommPortDriver->SendByte(show_id);
    int res;
    res = CommPortDriver->ReadData((char *)&show_struct[i],sizeof(ShowStruct));
    if(res != sizeof(ShowStruct)) {
        Application->MessageBox("Communication Error","Error",MB_OK	);
        return;
    }
    // terminate the string;
    show_struct[i].ShowName[15] = 0;
    Edit14->Text = show_struct[i].ShowName;
    ComboBox9->Text = show_struct[i].FrameRate;
    Edit13->Text = show_struct[i].NumChannels;
    if(show_struct[i].NumFrames!=0) {
        BitBtn14->Enabled = false;
        BitBtn15->Enabled= true;
        BitBtn16->Enabled= true;
    }else {
        BitBtn14->Enabled = true;
        BitBtn15->Enabled= false;
        BitBtn16->Enabled= false;

    }



}
//---------------------------------------------------------------------------

void __fastcall TForm1::TabSheet7Show(TObject *Sender)
{
    ComboBox8Change(this);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BitBtn16Click(TObject *Sender)
{
    if(BitBtn16->Caption == "Play") {
        CommPortDriver->SendByte('H');
        CommPortDriver->SendByte(ComboBox8->ItemIndex + 'A');
        CommPortDriver->SendByte('H');
        CommPortDriver->SendByte('0');
        BitBtn16->Caption = "Stop";
    } else {
        CommPortDriver->SendByte('H');
        CommPortDriver->SendByte('1');
        BitBtn16->Caption = "Play";

    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::BitBtn15Click(TObject *Sender)
{
    unsigned char data;

    CommPortDriver->SendByte('H');
    CommPortDriver->SendByte(ComboBox8->ItemIndex + 'A');

    CommPortDriver->SendByte('H');
    CommPortDriver->SendByte('5');

    int res;
    CommPortDriver->InputTimeout = 5000;
    res = CommPortDriver->ReadData(&data,1);
    CommPortDriver->InputTimeout = 1000;

    if(data!='!') {
        Application->MessageBox("Communication Error","Error",MB_OK	);
    }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::BitBtn14Click(TObject *Sender)
{
    int i;
    int show_id;
    int res;
    unsigned char *data_ptr;
    unsigned char buffer[6];

    i = ComboBox8->ItemIndex;
    if((i<0)||(i>25)) i =0;
    show_id = i+'A';

    if(BitBtn14->Caption == "Record") {

        strncpy(show_struct[i].ShowName,Edit14->Text.c_str(),15);
        show_struct[i].FrameRate =ComboBox9->Text.ToInt();
        show_struct[i].NumChannels = Edit13->Text.ToInt();

        CommPortDriver->FlushBuffers(true,true);

        CommPortDriver->SendByte('E');
        CommPortDriver->SendByte('2');
        CommPortDriver->SendByte(show_id);

        // empty the show
        show_struct[i].FirstFrameSector = 0xFFFF;

        data_ptr = (unsigned char *)&show_struct[i];

        for(i=0;i<sizeof(ShowStruct);i++) {
            CommPortDriver->SendByte(*data_ptr);
            res = CommPortDriver->ReadByte(buffer[0]);
            if((res == 0) || (buffer[0] != '!')) {
                Application->MessageBox("Communication Error","Error",MB_OK	);
                return;
            }
            data_ptr++;
        }

        CommPortDriver->FlushBuffers(true,true);

        CommPortDriver->SendByte('H');
        CommPortDriver->SendByte(ComboBox8->ItemIndex + 'A');
        CommPortDriver->SendByte('H');
        CommPortDriver->SendByte('4');
        BitBtn14->Caption = "Stop";
    } else {
        CommPortDriver->SendByte('H');
        BitBtn14->Caption = "Record";
    }

}
//---------------------------------------------------------------------------






void __fastcall TForm1::COM51Click(TObject *Sender)
{
     TMenuItem *item;
    int i;

    for(i=0;i<MainMenu->Items[0].Items[1]->Count;i++) MainMenu->Items[0].Items[1]->Items[i]->Checked = false;

    item = MainMenu->Items[0].Items[1]->Find("COM5");
    if(item == NULL) return;
    item->Checked = true;
    CommPortDriver->Disconnect();
    CommPortDriver->Port = pnCOM4;
    ConnectComPort();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::COM61Click(TObject *Sender)
{
     TMenuItem *item;
    int i;

    for(i=0;i<MainMenu->Items[0].Items[1]->Count;i++) MainMenu->Items[0].Items[1]->Items[i]->Checked = false;

    item = MainMenu->Items[0].Items[1]->Find("COM6");
    if(item == NULL) return;
    item->Checked = true;
    CommPortDriver->Disconnect();
    CommPortDriver->Port = pnCOM4;
    ConnectComPort();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::COM71Click(TObject *Sender)
{
     TMenuItem *item;
    int i;

    for(i=0;i<MainMenu->Items[0].Items[1]->Count;i++) MainMenu->Items[0].Items[1]->Items[i]->Checked = false;

    item = MainMenu->Items[0].Items[1]->Find("COM7");
    if(item == NULL) return;
    item->Checked = true;
    CommPortDriver->Disconnect();
    CommPortDriver->Port = pnCOM4;
    ConnectComPort();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::COM81Click(TObject *Sender)
{
     TMenuItem *item;
    int i;

    for(i=0;i<MainMenu->Items[0].Items[1]->Count;i++) MainMenu->Items[0].Items[1]->Items[i]->Checked = false;

    item = MainMenu->Items[0].Items[1]->Find("COM8");
    if(item == NULL) return;
    item->Checked = true;
    CommPortDriver->Disconnect();
    CommPortDriver->Port = pnCOM4;
    ConnectComPort();
}
//---------------------------------------------------------------------------



