//---------------------------------------------------------------------------

#ifndef mainH
#define mainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <Menus.hpp>
#include <ComCtrls.hpp>
#include <CheckLst.hpp>
#include "CPDrv.hpp"
#include <Dialogs.hpp>
#include "OpenDir.hpp"
#include <Grids.hpp>
#include "BmDelay.hpp"
//---------------------------------------------------------------------------

#define LOOP_FOREVER 101

#pragma pack(1)
typedef struct {
    char ShowName[16];
    // recording frame rate upto 44 times/sec
    unsigned char FrameRate;
    // number of DMX channels we record in each frame
    unsigned int NumChannels : 10;
    // time in seconds to cross fade between last show frame and first show frame
    unsigned int CrossFadeTime : 6;

	// first flash sector allocated to this show
	unsigned short FirstFrameSector;
	// total number of frames used by the show.
    unsigned long NumFrames;
}ShowStruct;

typedef struct {
       unsigned long TimeStamp;
       unsigned char Checksum;
}FrameHeader;

typedef  struct {
	// day is set to 0xFF is the show runs independently of the RTC
	unsigned char Day;
	unsigned char Month;
	unsigned char Hour;
	unsigned char Min;
	unsigned char Sec;
	unsigned char DayOfWeek;
    unsigned char KindOfTime;
}EEPROMTime;


typedef struct {
    // show number is 0xFF when this playlist entry is empty
    unsigned char ShowNum;
    unsigned char TimingFormat;
    EEPROMTime StartTime;
    EEPROMTime EndTime;
    // number of times the show has to loop
    unsigned char LoopTimes;
}PlaylistStruct;

#pragma pack()

class TForm1 : public TForm
{
__published:	// IDE-managed Components
    TMainMenu *MainMenu;
    TMenuItem *Exit1;
    TMenuItem *Setup1;
    TMenuItem *COM11;
    TMenuItem *COM21;
    TMenuItem *COM31;
    TMenuItem *COM41;
    TPageControl *PageControl1;
    TTabSheet *TabSheet1;
    TTabSheet *TabSheet2;
    TTabSheet *TabSheet3;
    TGroupBox *GroupBox1;
    TLabel *Label1;
    TCheckListBox *CheckListBox1;
    TBitBtn *BitBtn1;
    TBitBtn *BitBtn3;
    TTabSheet *TabSheet4;
    TCommPortDriver *CommPortDriver;
    TProgressBar *ProgressBar;
    TStatusBar *StatusBar;
    TOpenDialog *OpenDialog;
    TGroupBox *GroupBox2;
    TListBox *ListBox;
    TBitBtn *BitBtn2;
    TBitBtn *BitBtn4;
    TLabel *Label2;
    TGroupBox *GroupBox3;
    TLabel *Label3;
    TLabel *Label4;
    TBitBtn *BitBtn5;
    TLabel *Label5;
    TEdit *Edit1;
    TOpenDialog *OpenDialog1;
    TBitBtn *BitBtn6;
    TStringGrid *PlaylistStringGrid;
    TBmDelay *BmDelay1;
    TGroupBox *GroupBox4;
    TComboBox *ComboBox1;
    TLabel *Label6;
    TLabel *Label7;
    TComboBox *ComboBox2;
    TLabel *Label8;
    TLabel *Label9;
    TComboBox *ComboBox4;
    TDateTimePicker *DateTimePicker1;
    TLabel *Label10;
    TComboBox *ComboBox3;
    TLabel *Label11;
    TDateTimePicker *DateTimePicker2;
    TDateTimePicker *DateTimePicker3;
    TDateTimePicker *DateTimePicker4;
    TLabel *Label12;
    TComboBox *ComboBox5;
    TLabel *Label13;
    TComboBox *ComboBox6;
    TLabel *Label14;
    TComboBox *ComboBox7;
    TBitBtn *BitBtn7;
    TBitBtn *BitBtn8;
    TBitBtn *BitBtn9;
    TBitBtn *BitBtn10;
    TOpenDialog *OpenDialog2;
    TSaveDialog *SaveDialog1;
    TTabSheet *TabSheet5;
    TLabel *Label15;
    TLabel *Label16;
    TEdit *Edit2;
    TBitBtn *BitBtn11;
    TGroupBox *GroupBox5;
    TLabel *Label17;
    TEdit *Edit3;
    TLabel *Label18;
    TLabel *Label19;
    TEdit *Edit4;
    TEdit *Edit5;
    TLabel *Label20;
    TEdit *Edit6;
    TScrollBar *ScrollBar1;
    TLabel *Label21;
    TEdit *Edit7;
    TEdit *Edit8;
    TStringGrid *StringGrid;
    TGroupBox *GroupBox6;
    TLabel *Label22;
    TEdit *Edit9;
    TLabel *seconds;
    TGroupBox *GroupBox7;
    TSpeedButton *SpeedButton2;
    TEdit *Edit10;
    TSpeedButton *SpeedButton1;
    TEdit *Edit11;
    TButton *Button1;
    TLabel *Label23;
    TLabel *Label24;
    TLabel *Label25;
    TTabSheet *TabSheet6;
    TLabel *Label26;
    TEdit *Edit12;
    TBitBtn *BitBtn12;
    TBitBtn *BitBtn13;
    TGroupBox *GroupBox8;
    TLabel *Label27;
    TLabel *Label28;
    TOpenDialog *OpenDialog3;
    TTabSheet *TabSheet7;
    TGroupBox *GroupBox9;
    TLabel *Label29;
    TComboBox *ComboBox8;
    TComboBox *ComboBox9;
    TLabel *Label30;
    TLabel *Label31;
    TEdit *Edit13;
    TEdit *Edit14;
    TLabel *Label32;
    TBitBtn *BitBtn14;
    TBitBtn *BitBtn15;
    TBitBtn *BitBtn16;
    TOpenDirectory *OpenDirectory;
    TEdit *Edit15;
    TLabel *Label33;
    TLabel *Label34;
    TLabel *Label35;
    void __fastcall Exit1Click(TObject *Sender);
    void __fastcall COM11Click(TObject *Sender);
    void __fastcall COM21Click(TObject *Sender);
    void __fastcall COM31Click(TObject *Sender);
    void __fastcall COM41Click(TObject *Sender);
    void __fastcall COM51Click(TObject *Sender);
    void __fastcall COM61Click(TObject *Sender);
    void __fastcall COM71Click(TObject *Sender);
    void __fastcall COM81Click(TObject *Sender);
    void __fastcall FormShow(TObject *Sender);
    void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
    void __fastcall BitBtn3Click(TObject *Sender);
    void __fastcall BitBtn1Click(TObject *Sender);
    void __fastcall ListBoxDblClick(TObject *Sender);
    void __fastcall BitBtn2Click(TObject *Sender);
    void __fastcall BitBtn4Click(TObject *Sender);
    void __fastcall BitBtn6Click(TObject *Sender);
    void __fastcall BitBtn5Click(TObject *Sender);
    void __fastcall CommPortDriverReceivePacket(TObject *Sender,
          Pointer Packet, DWORD DataSize);
    void __fastcall BitBtn9Click(TObject *Sender);
    void __fastcall PlaylistStringGridSelectCell(TObject *Sender, int ACol,
          int ARow, bool &CanSelect);
    void __fastcall PlayListEditChange(TObject *Sender);
    void __fastcall TabSheet3Show(TObject *Sender);
    void __fastcall BitBtn7Click(TObject *Sender);
    void __fastcall BitBtn8Click(TObject *Sender);
    void __fastcall BitBtn11Click(TObject *Sender);
    void __fastcall ScrollBar1Change(TObject *Sender);
    void __fastcall Edit8Change(TObject *Sender);
    void __fastcall BitBtn10Click(TObject *Sender);
    void __fastcall SpeedButton1Click(TObject *Sender);
    void __fastcall SpeedButton2Click(TObject *Sender);
    void __fastcall Button1Click(TObject *Sender);
    void __fastcall BitBtn12Click(TObject *Sender);
    void __fastcall BitBtn13Click(TObject *Sender);
    void __fastcall ComboBox8Change(TObject *Sender);
    void __fastcall TabSheet7Show(TObject *Sender);
    void __fastcall BitBtn16Click(TObject *Sender);
    void __fastcall BitBtn15Click(TObject *Sender);
    void __fastcall BitBtn14Click(TObject *Sender);
private:	// User declarations
    ShowStruct show_struct[26];
    PlaylistStruct play_list_entries[100];
    bool got_boot_msg;
    bool boot_msg_err;
    bool cancel_boot;
    int selected_playlist_entry;
    bool save_show(int i,AnsiString location);
    bool change_coms_speed(int speed);
    bool restore_show(int index);
    bool get_playlist(int playlist);
    void update_playlist_grid(void);
    void update_playlist_edit_tab(PlaylistStruct *play_list_ptr);
    bool set_playlist(int playlist);
public:		// User declarations
    __fastcall TForm1(TComponent* Owner);
    void ConnectComPort(void);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
